/*
  Copyright (c) 2009 Yahoo! Inc. 
  All Rights Reserved
*/

function FoxyTunesChromeToContentBridge() {
}

FoxyTunesChromeToContentBridge.prototype = {
    init: function(doc) {
        // Don't create the bridge more than once
        var foxyTunesBridge = doc.getElementById('FoxyTunesBridge');
        if (foxyTunesBridge) return;

        foxyTunesBridge = doc.createElement('div');
        foxyTunesBridge.id = 'FoxyTunesBridge';
        foxyTunesBridge.style.display = 'none';
        doc.documentElement.appendChild(foxyTunesBridge);

        innerHTML = '';
        innerHTML += '(function (){';
        innerHTML += 'function foxytunesBridgeListener() {'; 
        innerHTML += '  var cmd = foxyTunesBridge.getAttribute("cmdToEval");'; 
        innerHTML += '  var rc = "";'; 
        innerHTML += '  try {'; 
        innerHTML += '      eval("rc = " + cmd);'; 
        innerHTML += '  } catch (e) {};'; 
 		innerHTML += '  if ((typeof rc == "string") || (typeof rc == "number") || (typeof rc == "boolean")) {';
        innerHTML += '      foxyTunesBridge.setAttribute("rc", rc);'; 
        innerHTML += '  } else {'; 
        innerHTML += '      foxyTunesBridge.setAttribute("rc", "");'; 
        innerHTML += '  }'; 
        innerHTML += '}'; 
        innerHTML += 'var foxyTunesBridge = document.getElementById("FoxyTunesBridge");';
        innerHTML += 'foxyTunesBridge.addEventListener("FTEvalCommand", foxytunesBridgeListener, true);';
        innerHTML += '})();';


        var script = doc.createElement('script');
        script.setAttribute('type', 'text/javascript');
        script.innerHTML = innerHTML;
        doc.getElementsByTagName('head')[0].appendChild(script);
    },

    fireCommand: function(doc, cmd) {
        // Just in case
     //   this.init(doc);

        var foxyTunesBridge = doc.getElementById('FoxyTunesBridge');
        if (!foxyTunesBridge) return;

        foxyTunesBridge.setAttribute('cmdToEval', cmd);
        var evt = doc.createEvent('Events');
        evt.initEvent('FTEvalCommand', true, false);
        foxyTunesBridge.dispatchEvent(evt); 
        var rc = foxyTunesBridge.getAttribute('rc');

        // Sanity
        foxyTunesBridge.setAttribute('cmdToEval', '');
        foxyTunesBridge.setAttribute('rc', '');

        return rc;
    },
}
